#include <iostream>
#include <queue>
using namespace std;
const int maxn = 7e2 + 50, maxlog = 10, inf = 1e7;
char t[maxn][maxn];
int pirate_time[maxn][maxn], n, m;
/*int sparse_row[maxlog][maxn][maxn];
int sparse_col[maxlog][maxn][maxn];*/

pair < int, int > p[] = { {-1, 0}, {0, -1}, {1, 0}, {0, 1} };

struct bfs_node {
    int x, y, time;
    bfs_node() {
        x = y = time = 0;
    }
    bfs_node(int _x, int _y, int _time) {
        x = _x; y = _y; time = _time;
    }
};

// !!!!!!!!! * по 0, n+1, m+1

queue < bfs_node > q;

void pirate_bfs(pair < int, int > start) {
    q.push({start.first, start.second, 1});
    pirate_time[start.first][start.second] = 1;
    while (!q.empty()) {
        auto top = q.front();
        q.pop();
        for (auto [dx, dy] : p) {
            top.x += dx;
            top.y += dy;

            if (t[top.x][top.y] != '*' && !pirate_time[top.x][top.y]) {
                pirate_time[top.x][top.y] = top.time+1;
                q.push({top.x, top.y, top.time+1});
            } 

            top.x -= dx;
            top.y -= dy;
        }
    }
}

void fill_borders() {
    for (int i = 0 ; i <= m+1 ; ++i) {
        t[0][i] = '*';
        t[n+1][i] = '*';
    } 
    for (int i = 0 ; i <= n+1 ; ++i) {
        t[i][0] = '*';
        t[i][m+1] = '*';
    } 
}

int get_log[maxn];

/*
void build_sparse() {

    for (int i = 1 ; i <= n ; ++i)
        for (int j = 1 ; j <= m ; ++j)
            sparse_row[0][i][j] = sparse_col[0][i][j] = pirate_time[i][j]; 

    for (int log = 1 ; (1 << log) <= m ; ++i) {
        for (int i = 1 ; i <= n ; ++i) {
            for (int j = 1 ; j + (1 << log)-1 <= m ; ++j) {
                sparse_row[log][i][j] = min(sparse_row[log-1][i][j], sparse_row[log-1][i][j + (1 << log-1)]);
            }
        }
    }

    for (int log = 1 ; (1 << log) <= n ; ++i) {
        for (int i = 1 ; i + (1 << log)-1 <= n ; ++i) {
            for (int j = 1 ; j <= m ; ++j) {
                sparse_col[log][i][j] = min(sparse_col[log-1][i][j], sparse_col[log-1][i + (1 << log-1)][j]);
            }
        }
    }

    int log = 0;
    for (int i = 1 ; i < maxn ; ++i) {
        if ((1 << log+1) < i) ++log;
        get_log[i] = log;
    }

}*/

int minimum_pirate_time[maxn][maxn];
int left_star[maxn][maxn];
int up_star[maxn][maxn];

/*
int get_row_min(int row, int l, int r) {
    if (l > r) return inf;
    int log = get_log[r-l+1];
    return min(sparse_row[log][row][l], sparse_row[log][row][r - (1 << log)+1]);
}

int get_col_min(int col, int l, int r) {
    if (l > r) return inf;
    int log = get_log[r-l+1];
    return min(sparse_row[log][l][col], sparse_row[log][r - (1 << log)+1][col]);
}
*/

void init_row_minimum() {
    for (int i = 1 ; i <= n ; ++i) left_star[i][0] = 0;

    int curr_minimum;

    for (int i = 1 ; i <= n ; ++i) {
        for (int j = 1 ; j <= m+1 ; ++j) {
            if (t[i][j] == '*') {
                curr_minimum = inf;
                //cout << "init row minimum time: "
                for (int x = left_star[i][j-1]+1 ; x < j ; ++x) {
                    curr_minimum = min(curr_minimum, pirate_time[i][x]);
                }
                for (int x = left_star[i][j-1]+1 ; x < j ; ++x) {
                    minimum_pirate_time[i][x] = curr_minimum;
                }
                left_star[i][j] = j;
            } else {
                left_star[i][j] = left_star[i][j-1];
            }
        }
    }

}

void init_col_minimum() {
    for (int i = 1 ; i <= m ; ++i) up_star[0][i] = 0;

    int curr_minimum;

    for (int j = 1 ; j <= m ; ++j) {
        for (int i = 1 ; i <= n+1 ; ++i) {
            if (t[i][j] == '*') {
                curr_minimum = inf;
                for (int x = up_star[i-1][j]+1 ; x < i ; ++x) {
                    curr_minimum = min(curr_minimum, pirate_time[x][j]);
                }
                for (int x = up_star[i-1][j]+1 ; x < i ; ++x) {
                    minimum_pirate_time[x][j] = min(minimum_pirate_time[x][j], curr_minimum);
                }
                up_star[i][j] = i;
            } else {
                up_star[i][j] = up_star[i-1][j];
            }
        }
    }

}

bool entered[maxn][maxn];

bool erma_bfs(pair < int, int > start, pair < int, int > finish) {
    q.push({start.first, start.second, 1});
    entered[start.first][start.second] = 1;
    while (!q.empty()) {
        auto top = q.front();
        q.pop();
        if (top.x == finish.first && top.y == finish.second) return 1;
        for (auto [dx, dy] : p) {
            top.x += dx;
            top.y += dy;

            if (t[top.x][top.y] != '*' && top.time+1 < minimum_pirate_time[top.x][top.y]) {
                entered[top.x][top.y] = 1;
                q.push({top.x, top.y, top.time+1});
            } 

            top.x -= dx;
            top.y -= dy;
        }
    }
    return 0;
}

pair < int, int > pirate_coord, erma_coord, save_coord;

int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;

    for (int i = 1 ; i <= n ; ++i) {
        for (int j = 1 ; j <= m ; ++j) {
            cin >> t[i][j];
            if (t[i][j] == 'E') erma_coord = {i, j};
            if (t[i][j] == 'P') pirate_coord = {i, j};
            if (t[i][j] == 'S') save_coord = {i, j};
        }
    }    

    fill_borders();
    pirate_bfs(pirate_coord);

    /*for (int i = 1 ; i <= n ; ++i) {
        for (int j = 1 ; j <= m ; ++j) {
            cout << pirate_time[i][j] << ' ';
        }
        cout << '\n';
    }*/

    //build_sparse();

    init_row_minimum();
    init_col_minimum();

    /*cout << "minimum time: \n";
    for (int i = 1 ; i <= n ; ++i) {
        for (int j = 1 ; j <= m ; ++j) {
            cout << minimum_pirate_time[i][j] << ' ';
        }
        cout << '\n';
    }*/

    cout << (erma_bfs(erma_coord, save_coord) ? "YES" : "NO") << '\n';

    return 0;

}