#include <iostream>
#include <algorithm>
#include <bitset>
using namespace std;
const int maxn = 2e4, maxsq = 1e2+10, buff_size = 2e5+10;


char buff[buff_size];
int buff_ix = buff_size-1;
void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}
void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || '9' < buff[buff_ix]; read_char());
    for (; '0' <= buff[buff_ix] && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}

pair < int, int > sorted[maxn];
int compr_cnt;

bitset < maxn > bs[maxsq];
bitset < maxn > curr;

int a[maxn], n, q, sq, bucket = 1, locate_bucket[maxn];
int l, r;

int query(int l, int r) {
    curr.reset();
    int beg_bucket = locate_bucket[l];
    int end_bucket = locate_bucket[r];
    
    if (locate_bucket[l] == locate_bucket[l-1]) {
        ++beg_bucket;
        for (int i = l ; locate_bucket[i] == locate_bucket[l] ; ++i) 
            curr[a[i]] = 1;
    }

    if (locate_bucket[r] == locate_bucket[r+1]) {
        --end_bucket;
        for (int i = r ; locate_bucket[i] == locate_bucket[r] ; --i) 
            curr[a[i]] = 1;
    }

    for (int i = beg_bucket ; i <= end_bucket ; ++i)
        curr |= bs[i];

    return curr.count();
}

signed main () {
    ios_base :: sync_with_stdio(0);
    cout.tie(nullptr);
    read_int(n);

    for (int i = 1 ; i <= n ; ++i) {
        read_int(a[i]);
        sorted[i] = {a[i], i};
    }
    sort(sorted+1, sorted+1+n);

    for (int i = 1 ; i <= n ; ++i) {
        compr_cnt += (sorted[i].first != sorted[i-1].first);
        a[sorted[i].second] = compr_cnt;
    }

    while (sq*sq < n) ++sq;
    //cout << "sq: " << sq << '\n';
    n = sq*sq;

    for (int i = 1 ; i <= n ; ++i) {
        bs[bucket][a[i]] = 1;
        locate_bucket[i] = bucket;
        if (i % sq == 0) {
            //cout << "bucket diff: " << bucket << ' ' << bs[bucket].count() << '\n';
            ++bucket;
        }
    }
    locate_bucket[n+1] = bucket;

    read_int(q);
    for (int i = 1 ; i <= q ; ++i) {
        read_int(l); read_int(r);
        cout << query(l, r) << '\n';

    }

    return 0;

}

/*
2
2
1
1 1 2
5 4 3
*/
