#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int maxn = 710;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

struct cell
{
    int x, y;

    cell operator + (cell p)
    {
        cell r;
        r.x = x + p.x;
        r.y = y + p.y;
        return r;
    }
};

cell neib[4] = {{0, 1}, {1, 0}, {-1, 0}, {0, -1}};
int n, m, bor[maxn][maxn], rl[maxn][maxn], used[maxn][maxn], a[maxn][maxn];
cell st, pir, en;
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
    {
        char c;
        cin >> c;
        if (c == 'E')
            st.x = i, st.y = j;
        else
        if (c == 'P')
            pir.x = i, pir.y = j;
        else
        if (c == 'S')
            en.x = i, en.y = j;
        else
        if (c == '*')
            used[i][j] = bor[i][j] = a[i][j] = 1;
    }

    for (int i = 0; i <= n; i ++)
        bor[i][0] = bor[i][m + 1] = used[i][0] = used[i][m + 1] = a[i][0] = a[i][m + 1] = 1;
    for (int j = 0; j <= m + 1; j ++)
        bor[0][j] = bor[n + 1][j] = used[0][j] = used[n + 1][j] = a[0][j] = a[n + 1][j] = 1;
}

void bfs_pirate()
{
    queue < cell > q;
    bor[pir.x][pir.y] = 1;
    q.push(pir);
    cell c;
    while(!q.empty())
    {
        c = q.front();
        q.pop();
        for (int i = 0; i < 4; i ++)
        {
            cell nb = c + neib[i];
            if (bor[nb.x][nb.y] == 0)
            {
                bor[nb.x][nb.y] = bor[c.x][c.y] + 1;
                q.push(nb);
            }
        }
    }

}

void fix_matrix()
{
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
    {
        if (a[i][j] == 1)
            rl[i][j] = 1;
        else
            rl[i][j] = 1e9;
    }

    for (int i = 1; i <= n; i ++)
    {
        int last = 0;
        for (int j = 1; j <= m; j ++)
        {
            if (a[i][j] != 1)
                continue;
            int minn = 1e9;
            for (int k = last + 1; k < j; k ++)
                if (bor[i][k] < minn)
                minn = bor[i][k];
            ///cout << i << " " << j << " " << minn << endl;
            for (int k = last + 1; k < j; k ++)
                rl[i][k] = min(rl[i][k], minn);
            last = j;
        }

        int minn = 1e9;
        for (int k = last + 1; k <= m; k ++)
            if (bor[i][k] < minn)
            minn = bor[i][k];
        for (int k = last + 1; k <= m; k ++)
            rl[i][k] = min(rl[i][k], minn);
    }

    for (int j = 1; j <= m; j ++)
    {
        int last = 0;
        for (int i = 1; i <= n; i ++)
        {
            if (a[i][j] != 1)
                continue;

            int minn = 1e9;
            for (int k = last + 1; k < i; k ++)
                if (bor[k][j] < minn)
                minn = bor[k][j];

            for (int k = last + 1; k < i; k ++)
                rl[k][j] = min(rl[k][j], minn);
            last = i;
        }

        int minn = 1e9;
        for (int k = last + 1; k <= n; k ++)
            if (bor[k][j] < minn)
                minn = bor[k][j];
        for (int k = last + 1; k <= n; k ++)
            rl[k][j] = min(rl[k][j], minn);
    }

    ///cout << "------------------------" << endl;
}

void bfs_erma()
{
    queue < cell > q;
    used[st.x][st.y] = 1;
    q.push(st);
    cell c;
    while(!q.empty())
    {
        c = q.front();
        q.pop();
        for (int j = 0; j < 4; j ++)
        {
            cell nb = c + neib[j];
            if (!used[nb.x][nb.y] && used[c.x][c.y] + 1 < rl[nb.x][nb.y])
            {
                used[nb.x][nb.y] = used[c.x][c.y] + 1;
                q.push(nb);
            }
        }
    }
}
void solve()
{
    bfs_pirate();
    fix_matrix();
    bfs_erma();
    if (used[en.x][en.y] != 0)
        cout << "YES" << endl;
    else
        cout << "NO" << endl;
    /*for (int i = 1; i <= n; i ++, cout << endl)
        for (int j = 1; j <= m; j ++)
        cout << bor[i][j] << " ";
    cout << "--------------" << endl;
            for (int i = 1; i <= n; i ++, cout << endl)
        for (int j = 1; j <= m; j ++)
        cout << rl[i][j] << " ";*/
}
int main()
{
    read();
    solve();
    return 0;
}

