#include <bits/stdc++.h>
#define endl '\n'

int n, m;
char grid[701][701];
bool piratesUsed[701][701], petkoUsed[701][701];
int piratesDist[701][701], petkoDist[701][701];
std::pair<int, int> pirates, petko, safe;
std::pair<int, int> directions[] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};
std::queue<std::pair<int, int> > q;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::cin >> n >> m;
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < m; ++ j) {
            std::cin >> grid[i][j];
            if (grid[i][j] == 'P') {
                pirates = {i, j};
            }
            if (grid[i][j] == 'E') {
                petko = {i, j};
            }
            if (grid[i][j] == 'S') {
                safe = {i, j};
            }
        }
    }
    // pirates bfs
    q.push(pirates);
    piratesUsed[pirates.first][pirates.second] = true;
    piratesDist[pirates.first][pirates.second] = 0;
    while (!q.empty()) {
        auto f = q.front();
        q.pop();
        for (int i = 0; i < 4; ++ i) {
            int x = f.first + directions[i].first, y = f.second + directions[i].second;
            if (x >= 0 && x < n && x >= 0 && y < m) {
                if (!piratesUsed[x][y]
                    && grid[x][y] != '*') {
                    piratesUsed[x][y] = true;
                    piratesDist[x][y] = piratesDist[f.first][f.second] + 1;
                    q.push({x, y});
                }
            }
        }
    }
    // petko bfs
    q.push(petko);
    petkoUsed[petko.first][petko.second] = true;
    petkoDist[petko.first][petko.second] = 0;
    while (!q.empty()) {
        auto f = q.front();
        q.pop();
        for (int i = 0; i < 4; ++ i) {
            int x = f.first + directions[i].first, y = f.second + directions[i].second;
            if (x >= 0 && x < n && y >= 0 && y < m) {
                if (!petkoUsed[x][y]
                    && grid[x][y] != '*') {
                    petkoUsed[x][y] = true;
                    bool captured = false;
                    // check if pirates can capture ship
                    for (int j = 0; j < 4; ++ j) {
                        int xc = x, yc = y;
                        while (grid[xc][yc] != '*' && xc >= 0 && xc < n && yc >= 0 && yc < m) {
                            if (piratesDist[xc][yc] <= petkoDist[f.first][f.second] + 1) {
                                captured = true;
                                break;
                            }
                            xc += directions[j].first; yc += directions[j].second;
                        }
                        if (captured) { break; }
                    }
                    if (!captured) {
                        petkoDist[x][y] = petkoDist[f.first][f.second] + 1;
                        q.push({x, y});
                    }
                }
            }
        }
    }
    if (petkoDist[safe.first][safe.second]) {
        std::cout << "YES" << endl;
    } else {
        std::cout << "NO" << endl;
    }
    return 0;
}
